'use strict';'require view';'require dom';'require ui';'require rpc';'require uci';'require form';'require fs';document.querySelector('head').appendChild(E('link',{'rel':'stylesheet','type':'text/css','href':L.resource('view/sensor-calibration/css/custom.css')}));function loadScript(scriptUrl){const script=document.createElement('script');script.src=scriptUrl;document.body.appendChild(script);return new Promise((res,rej)=>{script.onload=function(){res();}
script.onerror=function(){rej();}});}
var chart_attempts=0;var of_interest_sensors=['PF','VAC'];function loadChartsScript(){loadScript(L.resource('view/sensor-calibration/js/chart.umd.js')).then(()=>{if(document.getElementById('availableSensors').length>0){document.getElementById('availableSensors').disabled=false;}}).catch(()=>{chart_attempts++;if(chart_attempts<10){setTimeout(()=>{loadChartsScript();},2000);return;}else{alert('There was a problem loading the chart. Please refresh the page and try again.');console.error('Script loading failed! Handle this error');}}).finally(()=>{if(document.getElementById('availableSensors')&&document.getElementById('availableSensors').length>0){document.getElementById('availableSensors').disabled=false;}});}
loadChartsScript();addEventListener("visibilitychange",(event)=>{if(document.hidden){calibration.stopCalibration(true);}
qcSocket.connect().then(()=>{}).catch(()=>{});});var sensorArray=[];var calibration;var qcSocket;class qc{constructor(mac,type){this.offState=[];this.onState=[];this.defaultExpectedState='off';this.expectedState='';this.running=false;this.socketStatusId='socket-status';this.mac=mac;this.type=type;this.socketUrl=`ws://${location.host}:5081/calibration/`;this.initialPoints=0;this.charts=[];this.chartDisplays=[];this.sensors={machines:[],novatec_sensors:[],};this.progressObject={};this.sensorValues=[];this.ranges=[];}
async loadCalibration(){document.getElementById('chartContainer').innerHTML='';await this.loadNovatecSensors();this.loadSensors().then((sensors)=>{for(var i=0;i<sensors.length;i++){this.sensors.machines[sensors[i]['id']]=sensors[i];}
this.displayCalibrationValues();this.loadExpectedValues();this.loadCharts(this.sensors.machines).then(()=>{qcSocket.connect().then(()=>{}).catch(()=>{});});});}
async loadNovatecSensors(){const converted_mac=this.mac.replace(/:/g,'').toLowerCase();return new Promise((res,rej)=>{var sensors=uci.sections('novatec_sensors','sensor');for(var i=0;i<sensors.length;i++){if(sensors[i]['.name'].indexOf(converted_mac)!=-1){sensors[i]['id']=sensors[i]['.name'];this.sensors.novatec_sensors[sensors[i]['.name']]=sensors[i];}}
return res();});}
loadSensors(){var type=this.type;return new Promise((res,rej)=>{var sensors=uci.sections('machines','sensor');var filteredSensors=sensors.filter(s=>{if(type=='VFDI'){if(s.mac==this.mac&&(s.type=='VFDI'||s.type=='VFDO')){return true;}}
return s.mac==this.mac&&s.type==type;});return res(filteredSensors);});}
processMessage(message){if(typeof(this[message.event_name])=='function'){this[message.event_name](message);}}
loadCharts(sensors){var loadChartFunctions=[];var sensorKeys=Object.keys(sensors);for(var i=0;i<sensorKeys.length;i++){loadChartFunctions.push(this.loadChart(sensors[sensorKeys[i]]['id']));}
return Promise.all(loadChartFunctions);}
loadChart(chartElementId){var self=this;return new Promise((res,rej)=>{var chartContainer=document.getElementById('chartContainer');var sensorSection=document.createElement('div');sensorSection.classList.add('sensor-section');var sensorSectionH5=document.createElement('h5');sensorSectionH5.innerHTML=chartElementId;chartContainer.append(sensorSectionH5);for(var i=0;i<self.chartDisplays.length;i++){var chartDisplays=self.chartDisplays[i];var indChartContainer=document.createElement('div');indChartContainer.innerHTML='<h5>'+chartDisplays.label+'</h5>';if(self.chartDisplays.length>1){indChartContainer.style.maxWidth='49%';}
var chartEl=document.createElement('canvas');chartEl.id=chartElementId;chartEl.style.width='100%';chartEl.style.height='250px';indChartContainer.append(chartEl);sensorSection.append(indChartContainer);chartContainer.append(sensorSection);var chart=self.getChartObject(chartEl);chart.counter=0;for(var j=0;j<self.initialPoints;j++){chart.data.labels.push(j);}
self.charts[chartElementId+'-'+chartDisplays.key]=chart;}
res();return;});}
startCalibration(){if(qcSocket.isActive()==false){var md=ui.showModal(_('Sensor Calibration Error'),[E('p',{'class':'card-text'},_('Websocket connection is not established.')),E('div',{'class':'right'},[E('button',{'class':'cbi-button','click':()=>{ui.hideModal();}},[_('Ok')]),' ',])]);md.style.maxWidth='min(600px, 90%)';md.style.maxHeight='min(500px, 90%)';return;}
var chartKeys=Object.keys(this.charts);for(var i=0;i<chartKeys.length;i++){var chart=this.charts[chartKeys[i]];chart.counter=0;for(var j=0;j<chart.data.datasets.length;j++){chart.data.datasets[j].data=[];}
chart.data.labels=[];for(var j=0;j<this.initialPoints;j++){chart.data.labels.push(j);}
chart.update();}
var sensorIds=Object.keys(this.sensors.machines);for(var j=0;j<sensorIds.length;j++){var onStateArr=[];var offStateArr=[];for(var i=0;i<this.onState.length;i++){var onStateId=this.onState[i].id;if(onStateId!=''){var onStateVal=document.getElementById(onStateId+'-'+sensorIds[j]).value!=''?document.getElementById(onStateId+'-'+sensorIds[j]).value:this.onState[i].value;}else{var onStateVal=this.onState[i].value;}
onStateArr.push(onStateVal);}
for(var i=0;i<this.offState.length;i++){var offStateId=this.offState[i].id;if(offStateId!=''){var offStateVal=document.getElementById(offStateId+'-'+sensorIds[j]).value!=''?document.getElementById(offStateId+'-'+sensorIds[j]).value:this.offState[i].value;}else{var offStateVal=this.offState[i].value;}
offStateArr.push(offStateVal);}
this.sensors.machines[sensorIds[j]].onState=onStateArr;this.sensors.machines[sensorIds[j]].offState=offStateArr;}
this.expectedState=this.defaultExpectedState;var data={"cmd":"start","params":{"sensors":[]}}
var sensorsArr=[];var sensors=Object.keys(this.sensors.machines);for(var i=0;i<sensors.length;i++){var sensor=this.sensors.machines[sensors[i]];sensorsArr.push({"type":sensor.type,"mac":sensor.mac,"on":sensor.onState.join(','),"off":sensor.offState.join(','),"index":sensor.index?sensor.index:sensor.port?sensor.port:1});}
data['params']['sensors']=sensorsArr;var dataStr=JSON.stringify(data);this.clearExistingValues().then(()=>{qcSocket.send(dataStr);document.getElementById('startCalibration').disabled=true;document.getElementById('stopCalibration').disabled=false;this.updateProgress(this.progressObject.started);this.running=true;}).catch(()=>{console.log('unable to proceed, already calibrated');});}
stopCalibration(flag){var data={"cmd":"stop","params":{}}
var dataStr=JSON.stringify(data);qcSocket.send(dataStr);document.getElementById('startCalibration').disabled=false;document.getElementById('stopCalibration').disabled=true;if(flag){this.updateProgress(this.progressObject.cancelled);}else{this.updateProgress(this.progressObject.complete);}
this.running=false;}
buildExpectedStateInput(state,sensorId){var div=document.createElement('div');div.classList.add('expected-state-input');div.innerHTML='<label id="'+state.id+'-label">'+state.label+'</label><input id="'+state.id+'-'+sensorId+'" type="number" step=".01" placeholder="'+state.value.toString()+'" />';return div;}
loadExpectedValues(){var calibrationThresholds=document.getElementById('calibrationThresholds');if(calibrationThresholds){calibrationThresholds.innerHTML='';}
var calibrationDiv=document.createElement('div');calibrationDiv.innerHTML='<h5>Expected Values</h5>';calibrationThresholds.append(calibrationDiv);var sensorIds=Object.keys(this.sensors.machines);for(var j=0;j<sensorIds.length;j++){var div=document.createElement('div');var h5=document.createElement('h5');h5.classList.add('expected-values-id');if(j==0){h5.classList.add('active');}
h5.textContent=sensorIds[j];h5.dataset.id=sensorIds[j];calibrationDiv.append(h5);div.dataset.id=sensorIds[j];div.classList.add('expected-values');if(j==0){div.classList.add('active');}
for(var i=0;i<this.offState.length;i++){var state=this.offState[i];if(state.id!=''){if(i==0){var sectionLabel=document.createElement('p');sectionLabel.textContent='Off State';div.append(sectionLabel);}
div.append(this.buildExpectedStateInput(state,sensorIds[j]));}}
for(var i=0;i<this.onState.length;i++){var state=this.onState[i];if(state.id!=''){if(i==0){var sectionLabel=document.createElement('p');sectionLabel.textContent='On State';div.append(sectionLabel);}
div.append(this.buildExpectedStateInput(state,sensorIds[j]));}}
calibrationDiv.append(div);}
var expectedValuesHeaders=document.querySelectorAll('.expected-values-id');for(var i=0;i<expectedValuesHeaders.length;i++){expectedValuesHeaders[i].addEventListener('click',(ev)=>{var id=ev.target.dataset.id;var headers=document.querySelectorAll('.expected-values-id');for(var j=0;j<headers.length;j++){headers[j].classList.remove('active');}
var activeHeader=document.querySelector('.expected-values-id[data-id="'+id+'"]');if(activeHeader){activeHeader.classList.add('active');}
var values=document.querySelectorAll('.expected-values');for(var j=0;j<values.length;j++){values[j].classList.remove('active');}
var activeValues=document.querySelector('.expected-values[data-id="'+id+'"]');if(activeValues){activeValues.classList.add('active');}});}}
showSocketCloseError(){var md=ui.showModal(_('Sensor Calibration Error'),[E('div',{'id':'resultsModal'},[E('p',{'class':''},'The socket connection was closed for some reason, calibration has stopped.'),E('div',{'class':'right'},[E('button',{'class':'cbi-button','click':()=>{ui.hideModal();}},[_('Ok')]),' ',])])]);md.style.maxWidth='min(600px, 90%)';md.style.maxHeight='min(500px, 90%)';this.running=false;}
showCardModal(modal){var md=ui.showModal(modal.title,[E('div',{'id':'resultsModal'},[E('p',{'class':'card-text'},modal.body),E('div',{'class':'right'},[E('button',{'class':'cbi-button','click':()=>{ui.hideModal();}},[modal.buttonText]),' ',])])]);md.style.maxWidth='min(600px, 90%)';md.style.maxHeight='min(500px, 90%)';}
updateProgress(progress){const progressBar=document.getElementById('progressBarValue');progressBar.style.width=`${progress.progress}%`;progressBar.innerHTML=progress.text;progressBar.style.backgroundColor=progress.backgroundColor;progressBar.style.color=progress.color;}
getExistingValues(config_file){var calibValues=[];var sensorKeys=Object.keys(this.sensors[config_file]);for(var i=0;i<sensorKeys.length;i++){var sensor=this.sensors[config_file][sensorKeys[i]];var values={};for(var j=0;j<this.sensorValues.length;j++){var value=uci.get([config_file],sensor['.name'],this.sensorValues[j]['key']);if(value){values[this.sensorValues[j]['key']]=uci.get([config_file],sensor['.name'],this.sensorValues[j]['key']);}}
if(Object.keys(values).length>0){values.name=sensor['.name'];values.id=sensor['id'];calibValues.push(values);}}
return calibValues;}
checkForExistingValues(){var calibValues=this.getExistingValues('machines');if(calibValues.length>0){return calibValues;}
calibValues=this.getExistingValues('novatec_sensors');if(calibValues.length>0){return calibValues;}
return false;}
clearExistingValues(){return new Promise((res,rej)=>{const existingValues=this.checkForExistingValues();if(!existingValues){return res();}
var cards=[];var transformedValues=this.typeTransformCalibrationValues(existingValues);for(var i=0;i<existingValues.length;i++){var table=this.createDisplayTable(transformedValues[existingValues[i].id]);var cardEl=E('div',{'class':'card'},[E('div',{'class':'card-header'},[E('span',{},existingValues[i]['id']),]),E('div',{'class':'card-body'},table),]);cards.push(cardEl);}
var md=ui.showModal(_('Sensor Already Calibrated'),[E('div',{'id':'resultsModal'},[E('div',{},[E('div',{'class':'card'},[E('div',{'class':'card-body'},[E('p',{'class':'card-text'},'This sensor has already been calibrated. In order to begin calibration, you will need to clear the existing values and start the calibration again.')])]),].concat(cards)),E('div',{'class':'right'},[E('button',{'class':'cbi-button-positive important','click':()=>{this.unsetExistingValues();}},_('Clear Existing Values')),E('button',{'class':'cbi-button','click':()=>{ui.hideModal();return rej();}},[_('Dismiss')])])])]);md.style.maxWidth='min(600px, 90%)';md.style.maxHeight='min(500px, 90%)';});}
async unsetValues(config_file){return new Promise((resolve,reject)=>{var sensorValues=this.sensorValues;var sensors=this.sensors[config_file];var m=new L.form.Map(config_file);m.save(function(){var sensorKeys=Object.keys(sensors);for(var i=0;i<sensorKeys.length;i++){for(var j=0;j<sensorValues.length;j++){if(L.uci.get(config_file,sensors[sensorKeys[i]]['.name'],sensorValues[j]['key'])){L.uci.unset(config_file,sensors[sensorKeys[i]]['.name'],sensorValues[j]['key']);}}}}).then(()=>{resolve();return;}).catch((error)=>{reject(error);return;});});}
unsetExistingValues(){this.unsetValues('novatec_sensors').then(()=>{this.unsetValues('machines').then(()=>{L.uci.changes().then((changes)=>{let keys=Object.keys(changes);if(keys.length>0){L.uci.apply(true).then(()=>{L.ui.changes.renderChangeIndicator();startSpinner();setTimeout(()=>{stopSpinner();L.ui.hideModal();this.displayCalibrationValues()},5000);});}});});});}
async saveValues(config_file,values,sensor_id,sensor_values){var sensor_name=this.sensors[config_file][sensor_id]?this.sensors[config_file][sensor_id]['.name']:null;return new Promise(function(resolve,reject){if(!values){return resolve();}
if(!sensor_name){sensor_name=uci.add(config_file,'sensor',sensor_id);}
var m=new L.form.Map(config_file);m.save(function(){for(var i=0;i<sensor_values.length;i++){var currentValue=uci.get(config_file,sensor_name,sensor_values[i].key);var param=sensor_values[i].subParam&&values[sensor_values[i].param]?values[sensor_values[i].param][sensor_values[i].subParam]:values[sensor_values[i].param];if(!currentValue||param.toString()!=currentValue){L.uci.set(config_file,sensor_name,sensor_values[i].key,param.toString())}}}).then(()=>{resolve();return;});});}
setCalibrationValues(data){var values=data.calibration_parameters;var sensorValues=this.sensorValues;return Promise.all([this.saveValues('novatec_sensors',values,data.sensor_id,sensorValues),this.saveValues('machines',values,data.sensor_id,sensorValues)]);}
calibration_result(message){if(message.data&&message.data.success&&message.data.success=='false'){const modal={title:_('Sensor QC Failed'),body:message.data.sensor_pass_fail_reason,buttonText:_('Ok')}
this.showCardModal(modal);this.stopCalibration(true);return;}
var cardHeader,cardAdditional,additionalButtons;var sensorValues=this.sensorValues;this.setCalibrationValues(message.data).then(()=>{this.sensors.machines[message.data.sensor_id].calibration_result=message.data;var allCalibrationComplete=true;var sensorIds=Object.keys(this.sensors.machines);for(var i=0;i<sensorIds.length;i++){if(!this.sensors.machines[sensorIds[i]].calibration_result){allCalibrationComplete=false;}}
if(allCalibrationComplete){var calibrationResults=[];for(var i=0;i<sensorIds.length;i++){var data=this.sensors.machines[sensorIds[i]].calibration_result;if(data.success=='true'){this.updateProgress(this.progressObject.success);cardHeader=E('div',{'class':'card-header success'},[E('span',{},_('Sensor '+data.sensor_id+' Calibration Successful'))]);cardAdditional=[E('p',{'class':'card-text'},data.reason)];for(var j=0;j<sensorValues.length;j++){var paramValue=sensorValues[j].subParam?data.calibration_parameters[sensorValues[j].param][sensorValues[j].subParam]:data.calibration_parameters[sensorValues[j].param];var p=E('p',{'class':'card-text'},[E('strong',{},sensorValues[j].label),E('span',{},' '+paramValue.toString())]);cardAdditional.push(p);}
var card=[E('div',{'class':'card'},[cardHeader,E('div',{'class':'card-body'},cardAdditional)])];calibrationResults=calibrationResults.concat(card);additionalButtons=[new ui.ComboButton('0',{0:[_('Save & Apply')],1:[_('Apply unchecked')]},{classes:{0:'btn cbi-button cbi-button-positive important',1:'btn cbi-button cbi-button-negative important'},click:L.bind(function(ev,mode){L.uci.apply(mode=='0').then(()=>{L.ui.changes.renderChangeIndicator();L.ui.hideModal();this.displayCalibrationValues();})},this)}).render()];}else{this.updateProgress(this.progressObject.failed);cardHeader=E('div',{'class':'card-header failed'},[E('span',{},_('Sensor '+data.sensor_id+' Calibration Failed'))]);cardAdditional=[E('p',{'class':'card-text'},data.reason)];additionalButtons=[];var card=[E('div',{'class':'card'},[cardHeader,E('div',{'class':'card-body'},cardAdditional)])];calibrationResults=calibrationResults.concat([card]);}}
var md=ui.showModal(_('Sensor Calibration Results'),[E('div',{'id':'resultsModal'},calibrationResults),E('div',{'class':'right'},additionalButtons.concat([E('button',{'class':'cbi-button','click':()=>{ui.hideModal();this.displayCalibrationValues();}},[_('Dismiss')]),' ',]))]);md.style.maxWidth='min(600px, 90%)';md.style.maxHeight='min(500px, 90%)';document.getElementById('startCalibration').disabled=false;document.getElementById('stopCalibration').disabled=true;}});}
response(message){if(message.data.error&&message.data.error=="Already collecting, must stop before starting.."){const modal={title:_('Sensor Calibration Error'),body:message.data.error,buttonText:_('Ok')}
this.showCardModal(modal);this.stopCalibration(true);}}
displayCalibrationValues(){document.getElementById('calibrationValues').innerHTML='';var sensors=Object.keys(this.sensors.machines);if(sensors.length==0){return;}
var calibrationValues=this.checkForExistingValues();if(calibrationValues){var transformedValues=this.typeTransformCalibrationValues(calibrationValues);var calibValues=document.createElement('div');calibValues.innerHTML='<h5>Current Calibration Values</h5>';for(var i=0;i<calibrationValues.length;i++){var div=document.createElement('div');div.classList.add('calibration-values');if(i==0){div.classList.add('active');}
div.dataset.id=calibrationValues[i].id;var h5=document.createElement('h5');h5.classList.add('calibration-values-id');if(i==0){h5.classList.add('active');}
h5.textContent=calibrationValues[i].id;h5.dataset.id=calibrationValues[i].id;calibValues.append(h5);var table=this.createDisplayTable(transformedValues[calibrationValues[i].id]);div.append(table);calibValues.append(div);}
var calibButtons=document.createElement('div');calibButtons.setAttribute('class','calib-buttons');calibButtons.innerHTML='<button class="cbi-button" id="clearExistingValues">'+_('Clear Values')+'</button>';calibValues.append(calibButtons);if(L.ui.changes&&L.ui.changes.changes&&L.ui.changes.changes.machines){var saveButton=document.createElement('button');saveButton.setAttribute('class','cbi-button cbi-button-positive important');saveButton.setAttribute('id','saveValues');saveButton.textContent=_('Save Values');calibButtons.append(saveButton);}
document.getElementById('calibrationValues').append(calibValues);if(document.getElementById('clearExistingValues')){document.getElementById('clearExistingValues').addEventListener('click',()=>{this.unsetExistingValues();});}
if(document.getElementById('saveValues')){document.getElementById('saveValues').addEventListener('click',()=>{this.applyValues();});}
var calibrationValuesHeaders=document.querySelectorAll('.calibration-values-id');for(var i=0;i<calibrationValuesHeaders.length;i++){calibrationValuesHeaders[i].addEventListener('click',(ev)=>{var id=ev.target.dataset.id;var headers=document.querySelectorAll('.calibration-values-id');for(var j=0;j<headers.length;j++){headers[j].classList.remove('active');}
var activeHeader=document.querySelector('.calibration-values-id[data-id="'+id+'"]');if(activeHeader){activeHeader.classList.add('active');}
var values=document.querySelectorAll('.calibration-values');for(var j=0;j<values.length;j++){values[j].classList.remove('active');}
var activeValues=document.querySelector('.calibration-values[data-id="'+id+'"]');if(activeValues){activeValues.classList.add('active');}});}}}
createDisplayTable(values){var table=document.createElement('table');table.classList.add('calibration-values-table');var thTr=document.createElement('tr');for(var j=0;j<values.th.length;j++){var th=document.createElement('th');th.textContent=values.th[j];thTr.append(th);}
table.append(thTr);for(var j=0;j<values.tr.length;j++){var tr=document.createElement('tr');for(var k=0;k<values.tr[j].length;k++){var td=document.createElement('td');td.textContent=values.tr[j][k];tr.append(td);}
table.append(tr);}
return table;}
applyValues(){L.uci.apply(true).then(()=>{L.ui.changes.renderChangeIndicator();L.ui.hideModal();this.displayCalibrationValues();})}
typeTransformCalibrationValues(values){}}
class vacQc extends qc{constructor(mac){super(mac,'VAC');this.offState=[{value:14.7,label:"Off State",id:"OffState"}];this.onState=[{value:10,label:"On State",id:"OnState"}];this.initialPoints=240;this.sensorValues=[{label:'Calibration A',key:'calib_a',param:'a'},{label:'Calibration B',key:'calib_b',param:'b'}];this.chartDisplays=[{label:'Vac Calibration',key:'vac',ranges:{startRange:[5,20],endRange:[5,20]}}];this.loadCalibration();this.setProgressObject();}
setProgressObject(){this.progressObject={started:{text:'Started',progress:25,backgroundColor:'green',color:'white'},offStart:{text:'Off Stage',progress:50,backgroundColor:'green',color:'white'},onStart:{text:'On Stage',progress:75,backgroundColor:'green',color:'white'},complete:{text:'Complete',progress:100,backgroundColor:'green',color:'white'},success:{text:'Calibration Successful',progress:100,backgroundColor:'green',color:'white'},failed:{text:'Calibration Failed',progress:100,backgroundColor:'red',color:'white'},cancelled:{text:'Calibration Stopped',progress:100,backgroundColor:'red',color:'white'}}}
getChartObject(chartEl){var color=Chart.helpers.color;return new Chart(chartEl,{data:{labels:[],datasets:[{type:'line',label:"Expected",borderColor:"#000000",backgroundColor:color("#000000").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Observed",borderColor:"#4169e1",backgroundColor:color("#4169e1").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Off Start",borderColor:"#a020f0",backgroundColor:color("#a020f0").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Off End",borderColor:"#da70d6",backgroundColor:color("#da70d6").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"On Start",borderColor:"#fa8072",backgroundColor:color("#fa8072").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"On End",borderColor:"#cd5c5c",backgroundColor:color("#cd5c5c").alpha(1).rgbString(),data:[],pointRadius:1}]},options:{animation:false,}});}
point(message){var chart=this.charts[message.data.sensor_id+'-vac'];var data={x:chart.counter,y:parseFloat(message.data.values[0])}
chart.data.datasets[1].data.push(data);chart.data.datasets[0].data.push({x:chart.counter,y:this.expectedState=='on'?this.onState[0].value:this.offState[0].value});if(chart.counter>chart.data.labels[chart.data.labels.length-1]){chart.data.labels.push(chart.counter);}
chart.update();chart.counter++;}
state_change(message){this.expectedState=message.data.expected_state||message.data.state;if(message.data.state!=message.data.expected_state){var modal={title:_('Sensor Calibration Information'),body:'Vacuum is not in the correct state to collect data. Please turn vaccuum to '+message.data.expected_state+'.',buttonText:_('Dismiss')}
this.showCardModal(modal);}else{ui.hideModal();}}
batch_collection_started(message){var status=message.data.state;var chartId=message.data.sensor_id;var chart=this.charts[chartId+'-vac'];var data=[{x:chart.counter,y:this.chartDisplays[0].ranges.startRange[0]},{x:chart.counter,y:this.chartDisplays[0].ranges.startRange[1]}];if(status=='off'){chart.data.datasets[2].data=data;this.updateProgress(this.progressObject.offStart);}else{chart.data.datasets[4].data=data;this.updateProgress(this.progressObject.onStart);}
chart.update();}
batch_collection_complete(message){var status=message.data.state;var chartId=message.data.sensor_id;var chart=this.charts[chartId+'-vac'];var data=[{x:chart.counter,y:this.chartDisplays[0].ranges.endRange[0]},{x:chart.counter,y:this.chartDisplays[0].ranges.endRange[1]}];if(status=='off'){chart.data.datasets[3].data=data;var md=ui.showModal(_('Sensor Calibration Information'),[E('div',{'id':'infoModal'},[E('div',{'class':''},[E('div',{'class':''},[E('p',{'class':'card-text'},'Off state calibration complete. Please turn vaccuum on.'),])]),E('div',{'class':'right'},[E('button',{'class':'cbi-button','click':()=>{ui.hideModal();}},[_('Dismiss')]),' ',])])]);md.style.maxWidth='min(600px, 90%)';md.style.maxHeight='min(500px, 90%)';}else{chart.data.datasets[5].data=data;}
chart.update();}
collection_complete(message){var profileFile=message.data.profileFile;}
typeTransformCalibrationValues(values){var tablesObj=[];for(var i=0;i<values.length;i++){var value=values[i];var tableObj={sensor_id:value['id'],th:['Calibrations','Value'],tr:[]}
for(var k=0;k<2;k++){var type=k==0?'a':'b';var td=[type,value['calib_'+type]];tableObj.tr.push(td);}
tablesObj[value['id']]=tableObj;}
return tablesObj;}}
class paQc extends qc{constructor(mac,type){super(mac,type.toUpperCase());this.offState=[{value:0,label:"Off State",id:""},{value:0,label:"Off State",id:""},{value:0,label:"Off State",id:""},{value:0,label:"Off State",id:""},{value:0,label:"Off State",id:""},{value:0,label:"Off State",id:""},];this.onState=[{value:227,label:"V1",id:"V1"},{value:9.8,label:"I1",id:"I1"},{value:227,label:"V2",id:"V2"},{value:9.8,label:"I2",id:"I2"},{value:227,label:"V3",id:"V3"},{value:9.8,label:"I3",id:"I3"}];this.initialPoints=120;this.sensorValues=[{label:'Phase Voltage V1a',key:'voltage_phase1_a',param:'voltage_phase1_a',subParam:'v1'},{label:'Phase Voltage V2a',key:'voltage_phase2_a',param:'voltage_phase2_a',subParam:'v2'},{label:'Phase Voltage V3a',key:'voltage_phase3_a',param:'voltage_phase3_a',subParam:'v3'},{label:'Phase Voltage V1b',key:'voltage_phase1_b',param:'voltage_phase1_b',subParam:'v1'},{label:'Phase Voltage V2b',key:'voltage_phase2_b',param:'voltage_phase2_b',subParam:'v2'},{label:'Phase Voltage V3b',key:'voltage_phase3_b',param:'voltage_phase3_b',subParam:'v3'},{label:'Phase Current I1a',key:'current_phase1_a',param:'current_phase1_a',subParam:'i1'},{label:'Phase Current I2a',key:'current_phase2_a',param:'current_phase2_a',subParam:'i2'},{label:'Phase Current I3a',key:'current_phase3_a',param:'current_phase3_a',subParam:'i3'},{label:'Phase Current I1b',key:'current_phase1_b',param:'current_phase1_b',subParam:'i1'},{label:'Phase Current I2b',key:'current_phase2_b',param:'current_phase2_b',subParam:'i2'},{label:'Phase Current I3b',key:'current_phase3_b',param:'current_phase3_b',subParam:'i3'}];this.chartDisplays=[{label:'Voltage (V)',key:'v',ranges:{startRange:[0,300],endRange:[0,300]}},{label:'Current (A)',key:'i',ranges:{startRange:[0,20],endRange:[0,20]}}];this.loadCalibration();this.setProgressObject();}
setProgressObject(){this.progressObject={started:{text:'Started',progress:25,backgroundColor:'green',color:'white'},offStart:{text:'Off Stage',progress:50,backgroundColor:'green',color:'white'},onStart:{text:'On Stage',progress:75,backgroundColor:'green',color:'white'},complete:{text:'Complete',progress:100,backgroundColor:'green',color:'white'},success:{text:'Calibration Successful',progress:100,backgroundColor:'green',color:'white'},failed:{text:'Calibration Failed',progress:100,backgroundColor:'red',color:'white'},cancelled:{text:'Calibration Stopped',progress:100,backgroundColor:'red',color:'white'}}}
getChartObject(chartEl){var color=Chart.helpers.color;return new Chart(chartEl,{counter:0,data:{labels:[],datasets:[{type:'line',label:"Expected 1",borderColor:"#000000",backgroundColor:color("#000000").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Expected 2",borderColor:"#333333",backgroundColor:color("#333333").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Expected 3",borderColor:"#666666",backgroundColor:color("#666666").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Phase 1",borderColor:"#4169e1",backgroundColor:color("#4169e1").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Phase 2",borderColor:"#2346af",backgroundColor:color("#2346af").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Phase 3",borderColor:"#0d2878",backgroundColor:color("#0d2878").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Off Start",borderColor:"#a020f0",backgroundColor:color("#a020f0").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"Off End",borderColor:"#da70d6",backgroundColor:color("#da70d6").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"On Start",borderColor:"#fa8072",backgroundColor:color("#fa8072").alpha(1).rgbString(),data:[],pointRadius:1},{type:'line',label:"On End",borderColor:"#cd5c5c",backgroundColor:color("#cd5c5c").alpha(1).rgbString(),data:[],pointRadius:1}]},options:{animation:false,plugins:{legend:{display:true,position:'bottom',align:'start',labels:{padding:15,textAlign:'left',boxWidth:10,boxHeight:10}}}}});}
point(message){for(var j=0;j<this.chartDisplays.length;j++){var chart=this.charts[message.data.sensor_id+'-'+this.chartDisplays[j].key];for(var i=0;i<3;i++){var data={x:chart.counter,y:parseFloat(message.data.values[(i*2)+j])}
chart.data.datasets[i+3].data.push(data);chart.data.datasets[i].data.push({x:chart.counter,y:this.expectedState=='on'?this.onState[(i*2)+j].value:this.offState[(i*2)+j].value});if(chart.counter>chart.data.labels[chart.data.labels.length-1]){chart.data.labels.push(chart.counter);}
chart.update();}
chart.counter++;}}
state_change(message){this.expectedState=message.data.expected_state||message.data.state;if(message.data.state!=message.data.expected_state){var modal={title:_('Sensor Calibration Information'),body:'Sensor is not in the correct state to collect data. Please turn sensor to '+message.data.expected_state+'.',buttonText:_('Dismiss')}
this.showCardModal(modal);}else{ui.hideModal();}}
batch_collection_started(message){for(var i=0;i<this.chartDisplays.length;i++){var status=message.data.state;var chartId=message.data.sensor_id;this.sensors.machines[chartId].batch_status='started';var chart=this.charts[chartId+'-'+this.chartDisplays[i].key];var data=[{x:chart.counter,y:this.chartDisplays[i].ranges.startRange[0]},{x:chart.counter,y:this.chartDisplays[i].ranges.startRange[1]}];if(chart.counter>this.initialPoints){chart.data.labels.push(chart.counter);chart.update();}
if(status=='off'){chart.data.datasets[6].data=data;this.updateProgress(this.progressObject.offStart);}else{chart.data.datasets[8].data=data;this.updateProgress(this.progressObject.onStart);}
chart.update();}}
batch_collection_complete(message){for(var i=0;i<this.chartDisplays.length;i++){var status=message.data.state;var chartId=message.data.sensor_id;this.sensors.machines[chartId].batch_status='completed';var chart=this.charts[chartId+'-'+this.chartDisplays[i].key];var lastChartLabel=chart.data.labels[chart.data.labels.length-1];for(var j=(lastChartLabel+1);j<(lastChartLabel+10);j++){chart.data.labels.push(j);}
chart.update();var data=[{x:chart.counter,y:this.chartDisplays[i].ranges.endRange[0]},{x:chart.counter,y:this.chartDisplays[i].ranges.endRange[1]}];if(status=='off'){var sensorIds=Object.keys(this.sensors.machines);var sensorsBatchComplete=true;for(var j=0;j<sensorIds.length;j++){if(this.sensors.machines[sensorIds[j]].batch_status!='completed'){sensorsBatchComplete=false;}}
chart.data.datasets[7].data=data;if(sensorsBatchComplete){var md=ui.showModal(_('Sensor Calibration Information'),[E('div',{'id':'infoModal'},[E('div',{'class':''},[E('div',{'class':''},[E('p',{'class':'card-text'},'Off state calibration complete. Please turn sensors on.'),])]),E('div',{'class':'right'},[E('button',{'class':'cbi-button','click':()=>{ui.hideModal();}},[_('Dismiss')]),' ',])])]);md.style.maxWidth='min(600px, 90%)';md.style.maxHeight='min(500px, 90%)';}}else{chart.data.datasets[9].data=data;}
chart.update();}}
collection_complete(message){var profileFile=message.data.profileFile;}
typeTransformCalibrationValues(values){var tablesObj=[];for(var i=0;i<values.length;i++){var value=values[i];var tableObj={sensor_id:value['id'],th:['Type','Phase','Voltage','Current'],tr:[]}
for(var k=0;k<2;k++){var type=k==0?'a':'b';for(var j=1;j<=3;j++){var td=[type,j,value['voltage_phase'+j+'_'+type],value['current_phase'+j+'_'+type]];tableObj.tr.push(td);}}
tablesObj[value['id']]=tableObj;}
return tablesObj;}}
class socket{constructor(calibrationObject){this.connection=null;this.calibrationObject=calibrationObject;}
isActive(){return this.connection&&this.connection.readyState==WebSocket.OPEN;}
isNotClosed(){return this.connection&&this.connection.readyState!=WebSocket.CLOSED;}
connect(){let self=this;return new Promise((res,rej)=>{if(self.isNotClosed()){rej();return;}
let connection=new WebSocket(self.calibrationObject.socketUrl);connection.onmessage=async function(event){const data=JSON.parse(event.data);self.calibrationObject.processMessage(data);}
connection.onopen=function(event){self.updateDomSocketStatus('green','Ready');connection.send('{"x":"hello"}')
res();}
connection.onclose=function(event){self.updateDomSocketStatus('red','Not Ready');self.connection=null;if(self.calibrationObject.showErrorOnClose&&self.calibrationObject.running){self.calibrationObject.showSocketCloseError();}
setTimeout(function(){self.connect().then(res).catch(rej);},5000,self);rej();}
connection.onerror=function(event){self.updateDomSocketStatus('orange','Error');rej();}
self.connection=connection;return;});}
send(message){if(this.isActive()){this.connection.send(message);}else{}}
close(){if(this.isActive()){this.connection.close();}else{}}
updateDomSocketStatus=function(color,status_msg){var socketStatus=document.getElementById(this.calibrationObject.socketStatusId);socketStatus.style.background=color;socketStatus.innerHTML='<span>'+status_msg+'</span>';}};const initCalibration=(sensor)=>{var sensorArr=sensor.split('|');var mac=sensorArr[0];var type=sensorArr[1];switch(type.toLowerCase()){case'vac':calibration=new vacQc(mac);break;case'pf':case'vfdi':calibration=new paQc(mac,type.toLowerCase());break;}
if(!calibration){alert('This sensor type is not supported');return;}
document.getElementById('startCalibration').disabled=false;if(!qcSocket){qcSocket=new socket(calibration);}else{qcSocket.calibrationObject=calibration;qcSocket.close();}}
return view.extend({load:async function(){this.sensors={machines:[],novatec_sensors:[]};this.sensors.machines=[];this.sensors.novatec_sensors=[];await fs.read('/etc/config/machines').catch(()=>{fs.write('/etc/config/machines',' ');});await fs.read('/etc/config/novatec_sensors').catch(()=>{fs.write('/etc/config/novatec_sensors',' ');});return Promise.all([uci.load('machines'),uci.load('novatec_sensors')]).then((data)=>{var sensors=uci.sections('machines','sensor');var uniqueSensors=[];var sensorMacs=[];for(var i=0;i<sensors.length;i++){if(sensorMacs.indexOf(sensors[i]['mac'].toUpperCase())==-1&&of_interest_sensors.indexOf(sensors[i]['type'].toUpperCase())!=-1){sensorMacs.push(sensors[i]['mac'].toUpperCase());uniqueSensors.push(sensors[i]);}}
this.sensors.machines=uniqueSensors;});},getOptions:function(){var options=[E('option',{},'Select MAC')];var optionsArr=this.sensors.machines.map((s)=>{return E('option',{'value':s.mac.toUpperCase()+'|'+s.type},s.mac.toUpperCase()+' - '+s.type);})
options.push(...optionsArr);return options;},render:function(){var body=E([E('div',{'id':'calibrationContainer'},[E('h2',_('Sensor Calibration')),E('div',{'id':'socket-status'},'Connecting to Server'),E('p',{},_('Calibrate your Sensor')),E('hr'),E('div',{'id':'sensor-calibration'},[E('div',{'id':'calibration-controls'},[E('p',{},[E('label',{},_('Select Sensor MAC')),E('select',{'id':'availableSensors','disabled':'disabled',change:(e)=>{initCalibration(e.target.value);}},this.getOptions()),]),E('p',{},[E('button',{'id':'startCalibration','disabled':'disabled','click':()=>{calibration.startCalibration();}},_('Start Calibration')),E('button',{'id':'stopCalibration','disabled':'disabled','click':()=>{calibration.stopCalibration(true);}},_('Stop Calibration')),]),E('div',{'id':'calibSections'},[E('div',{'id':'calibrationThresholds'},[]),E('div',{'id':'calibrationValues'},[])])]),E('div',{'id':'calibrationProgress'},[E('h5',{},'Calibration Progress'),E('div',{'id':'progressBar'},[E('span',{'id':'progressBarValue'},'Waiting to Start')])]),E('div',{'id':'calibrationResult'},[E('p',{'id':'calibrationMessage'})]),E('div',{'id':'chartContainer'},[])])])]);return body;}});